<?php

namespace Apifon\Model\request;


use Apifon\Resource\helpers\PaginatedRequest;

require_once("./Apifon/Resource/helpers/PaginatedRequest.php");

class ListQueryRequest extends PaginatedRequest
{
    protected $type;
    protected $fields = array();
    protected $list_id;

    public function toQueryParamRequest()
    {
        $defaultFields = '?'.(http_build_query(array('size' => $this->size, 'page' => $this->page, 'sort' => $this->sort, 'sort_dir' => $this->sort_dir)));
        if($this->type) {
            $defaultFields = $defaultFields."&type=".$this->type;
        }
        if($this->fields) {
            $fieldsString = join(',',$this->fields);
            $defaultFields = $defaultFields."&fields=".$fieldsString;
        }
        return $defaultFields;
    }

    public function SingleFieldQueryParams()
    {
        $defaultFields = '';
        if($this->fields) {
            $fieldsString = join(',',$this->fields);
            $defaultFields = "?fields=".$fieldsString;
        }
        return $defaultFields;
    }

    public function getType()
    {
        return $this->type;
    }

    public function setType($type)
    {
        $this->type = $type;
    }

    public function getFields()
    {
        return $this->fields;
    }

    public function setFields(...$fields)
    {
        return $this->fields = $fields;
    }

    public function getListId()
    {
        return $this->list_id;
    }

    public function setListId($list_id)
    {
        $this->list_id = $list_id;
    }

    public function clearObj()
    {
        $ref = new \ReflectionClass(get_class($this));
        $ownProps = array_filter($ref->getProperties(), function($property) {
            return $property->class == get_class($this);
        });

        foreach ($ownProps as $value) {
            if($this->{$value->getName()}) {
                $this->{$value->getName()} = NULL;
            }
            if($value->getName() === 'fields') {
                $this->{$value->getName()} = array();
            }
        }
    }
}