<?php

namespace Apifon\Model\request;

require_once("./Apifon/Model/CampaignDefaults.php");
require_once("./Apifon/Model/GdprProperties.php");
require_once("./Apifon/Model/IRequest.php");

use Apifon\Model\CampaignDefaults;
use Apifon\Model\GdprProperties;
use Apifon\Model\IRequest;

class ListRequest implements IRequest
{
    protected $listId;
    protected $type;
    protected $title;
    protected $description;
    protected $prefix;
    protected $campaign_defaults;
    protected $gdpr_properties;

    public function getListId()
    {
        return $this->listId;
    }

    public function setListId($listId)
    {
        return $this->listId = $listId;
    }

    public function getType()
    {
        return $this->type;
    }

    public function setType($type)
    {
        return $this->type = $type;
    }

    public function getTitle()
    {
        return $this->title;
    }

    public function setTitle($title)
    {
        return $this->title = $title;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function setDescription($description)
    {
        return $this->description = $description;
    }

    public function getPrefix()
    {
        return $this->prefix;
    }

    public function setPrefix($prefix)
    {
        return $this->prefix = $prefix;
    }

    public function campaignDefaultsBuilder()
    {
        return new CampaignDefaults();
    }

    public function gdprPropertiesBuilder()
    {
        return new GdprProperties();
    }

    public function getCampaignDefaults()
    {
        return $this->campaign_defaults;
    }

    public function setCampaignDefaults($campaign_defaults)
    {
        return $this->campaign_defaults = $campaign_defaults;
    }

    public function getGdprProperties()
    {
        return $this->gdpr_properties;
    }

    public function setGdprProperties($gdpr_properties)
    {
        return $this->gdpr_properties = $gdpr_properties;
    }

    public function getBody()
    {
        return preg_replace('/,\s*"[^"]+":null|"[^"]+":null,?/', '', json_encode(get_object_vars($this)));
    }

    public function getCreateBody()
    {
        throw new Exception('Not implemented');
    }

    public function getReadBody()
    {
        throw new Exception('Not implemented');
    }

    public function getUpdateBody()
    {
        throw new Exception('Not implemented');
    }

    public function getDeleteBody()
    {
        throw new Exception('Not implemented');
    }

    public function clearObj()
    {
        $ref = new \ReflectionClass(get_class($this));
        $ownProps = array_filter($ref->getProperties(), function($property) {
            return $property->class == get_class($this);
        });

        foreach ($ownProps as $value) {
            if($this->{$value->getName()}) {
                $this->{$value->getName()} = NULL;
            }
        }
    }

}