<?php

	namespace Apifon\Model\request;

	require_once("Apifon/Model/IRequest.php");

	use Apifon\Model\IRequest;

	class OAuthConfigurationRequest implements IRequest
	{
		protected $grantType;
		protected $clientId;
		protected $scope;
		protected $clientSecret;
		protected $pkceChallenge;
		protected $redirectUri;
		protected $state;
		protected $token;

		function __construct($clientId, $clientSecret)
		{
			$this->clientId = $clientId;
			$this->clientSecret = $clientSecret;
		}

		public function getGrantType()
		{
			return $this->grantType;
		}

		public function setGrantType($grantType)
		{
			return $this->grantType = $grantType;
		}

		public function getClientId()
		{
			return $this->clientId;
		}

		public function setClientId($clientId)
		{
			return $this->clientId = $clientId;
		}

		public function getScope()
		{
			return $this->scope;
		}

		public function setScope($scope)
		{
			return $this->scope = $scope;
		}

		public function getToken()
		{
			return $this->token;
		}

		public function setToken($token)
		{
			return $this->token = $token;
		}

		public function getClientSecret()
		{
			return $this->clientSecret;
		}

		public function setClientSecret($clientSecret)
		{
			return $this->clientSecret = $clientSecret;
		}

		public function getPkceChallenge()
		{
			return $this->pkceChallenge;
		}

		public function setPkceChallenge($pkceChallenge)
		{
			return $this->pkceChallenge = $pkceChallenge;
		}

		public function getRedirectUri()
		{
			return $this->redirectUri;
		}

		public function setRedirectUri($redirectUri)
		{
			return $this->redirectUri = $redirectUri;
		}

		public function getState()
		{
			return $this->state;
		}

		public function setState($state)
		{
			return $this->state = $state;
		}

		public function getBody()
		{
			return preg_replace('/,\s*"[^"]+":null|"[^"]+":null,?/', '', json_encode(get_object_vars($this)));
		}

		public function getCreateBody()
		{
			throw new Exception('Not implemented');
		}

		public function getReadBody()
		{
			throw new Exception('Not implemented');
		}

		public function getUpdateBody()
		{
			throw new Exception('Not implemented');
		}

		public function getDeleteBody()
		{
			throw new Exception('Not implemented');
		}

		public function clearObj()
		{
			$ref = new \ReflectionClass(get_class($this));
			$ownProps = array_filter($ref->getProperties(), function ($property) {
				return $property->class == get_class($this);
			});

			foreach ($ownProps as $value) {
				if ($this->{$value->getName()}) {
					$this->{$value->getName()} = NULL;
				}
			}
		}

	}
