<?php

namespace Apifon\Model\request;

require_once("./Apifon/Model/ConditionsRequest.php");
require_once("./Apifon/Model/SortingRequest.php");

use Apifon\Model\ConditionsRequest;
use Apifon\Model\SortingRequest;

class QuerySubscribersBodyRequest
{
    protected $conditions = array();
    protected $sort;
    protected $fields = array();
    protected $page = 1;
    protected $size = 20;
    protected $listId;

    public function getConditions()
    {
        return $this->conditions;
    }

    public function setConditions($conditions)
    {
        $this->conditions[] = $conditions;
    }

    public function conditionsBuilder()
    {
        return new ConditionsRequest();
    }

    public function getSort()
    {
        return $this->sort;
    }

    public function setSort($sort)
    {
        $this->sort = $sort;
    }

    public function sortingBuilder()
    {
        return new SortingRequest();
    }

    public function getFields()
    {
        return $this->fields;
    }

    public function setFields(...$fields)
    {
        $this->fields = $fields;
    }

    public function getPage()
    {
        return $this->page;
    }

    public function setPage($page)
    {
        $this->page = $page;
    }

    public function getSize()
    {
        return $this->size;
    }

    public function setSize($size)
    {
        $this->size = $size;
    }

    public function getListId()
    {
        return $this->listId;
    }

    public function setListId($listId)
    {
        $this->listId = $listId;
    }

    public function getBody()
    {
        return preg_replace('/,\s*"[^"]+":null|"[^"]+":null,?/', '', json_encode(get_object_vars($this)));
    }

    public function getCreateBody()
    {
        throw new Exception('Not implemented');
    }

    public function getReadBody()
    {
        throw new Exception('Not implemented');
    }

    public function getUpdateBody()
    {
        throw new Exception('Not implemented');
    }

    public function getDeleteBody()
    {
        throw new Exception('Not implemented');
    }
}