<?php

namespace Apifon\Model\request;


use Apifon\Resource\helpers\PaginatedRequest;

require_once("./Apifon/Resource/helpers/PaginatedRequest.php");

class SubscriberQueryRequest extends PaginatedRequest
{
    protected $status;
    protected $email;
    protected $listId;
    protected $lookup_md5;
    protected $fields = array();

    public function toQueryParamRequest()
    {
        $defaultFields = '?'.(http_build_query(array('size' => $this->size, 'page' => $this->page, 'sort' => $this->sort, 'sort_dir' => $this->sort_dir)));
        if($this->email) {
            $defaultFields = $defaultFields."&email=".$this->email;
        }
        if($this->status) {
            $defaultFields = $defaultFields."&status=".$this->status;
        }

        if($this->fields) {
            $fieldsString = join(',',$this->fields);
            $defaultFields = $defaultFields."&fields=".$fieldsString;
        }
        return $defaultFields;
    }

    public function SingleFieldQueryParams()
    {
        $defaultFields = '';
        if($this->fields) {
            $fieldsString = join(',',$this->fields);
            $defaultFields = "?fields=".$fieldsString;
        }
        return $defaultFields;
    }

    public function getStatus()
    {
        return $this->status;
    }

    public function setStatus($status)
    {
        $this->status = $status;
    }

    public function getEmail()
    {
        return $this->email;
    }

    public function setEmail($email)
    {
        $this->email = $email;
    }

    public function getListId()
    {
        return $this->listId;
    }

    public function setListId($listId)
    {
        $this->listId = $listId;
    }

    public function getFields()
    {
        return $this->fields;
    }

    public function setFields(...$fields)
    {
        $this->fields = $fields;
    }

    public function getLookupMd5()
    {
        return $this->lookup_md5;
    }

    public function setLookupMd5($lookup_md5)
    {
        $this->lookup_md5 = $lookup_md5;
    }

    public function clearObj()
    {
        $ref = new \ReflectionClass(get_class($this));
        $ownProps = array_filter($ref->getProperties(), function($property) {
            return $property->class == get_class($this);
        });

        foreach ($ownProps as $value) {
            if($this->{$value->getName()}) {
                $this->{$value->getName()} = NULL;
            }
            if($value->getName() === 'fields'){
                $this->{$value->getName()} = array();
            }
        }
    }

}