<?php

namespace Apifon\Model\request;

require_once("./Apifon/Model/GdprFieldConsent.php");

use \Exception;
use Apifon\Model\GdprFieldConsent;

class SubscriberRequest
{
    protected $listId;
    protected $destination;
    protected $email;
    protected $status;
    protected $email_status;
    protected $subscriber_fields;
    protected $gdpr_fields;
    protected $groupOptions = array();

    public function getGroupOptions()
    {
        return $this->groupOptions;
    }

    public function setGroupOptions(...$groupOptions)
    {
            $this->groupOptions = $groupOptions;
    }

    private function createGdprPropery($key, $value)
    {
        $this->{$key} = $value;
    }

    public function getListId()
    {
        return $this->listId;
    }

    public function setListId($listId)
    {
        return $this->listId = $listId;
    }

    public function getDestination()
    {
        return $this->destination;
    }

    public function setDestination($destination)
    {
        return $this->destination = $destination;
    }

    public function getEmail()
    {
        return $this->email;
    }

    public function setEmail($email)
    {
        return $this->email = $email;
    }

    public function getStatus()
    {
        return $this->status;
    }

    public function setStatus($status)
    {
        return $this->status = $status;
    }

    public function getEmailStatus()
    {
        return $this->email_status;
    }

    public function setEmailStatus($email_status)
    {
        return $this->email_status = $email_status;
    }


    public function getSubscriberFields()
    {
        return $this->subscriber_fields;
    }

    public function setSubscriberFields($subscriber_fields)
    {
        if(!is_array($subscriber_fields)){
            throw new Exception('Subscriber field property must be a key->value structure');
        }
        $this->subscriber_fields = $subscriber_fields;
    }

    public function gdprFieldConsentBuilder()
    {
        return new GdprFieldConsent();
    }

    public function getGdprFields()
    {
        return $this->gdpr_fields;
    }

    public function setGdprFields($gdpr_fields)
    {
        $this->gdpr_fields = $gdpr_fields;
    }


    public function getBody()
    {
        return preg_replace('/,\s*"[^"]+":null|"[^"]+":null,?/', '', json_encode(get_object_vars($this)));
    }

    public function getCreateBody()
    {
        throw new Exception('Not implemented');
    }

    public function getReadBody()
    {
        throw new Exception('Not implemented');
    }

    public function getUpdateBody()
    {
        throw new Exception('Not implemented');
    }

    public function getDeleteBody()
    {
        throw new Exception('Not implemented');
    }

    public function clearObj()
    {
        $ref = new \ReflectionClass(get_class($this));
        $ownProps = array_filter($ref->getProperties(), function($property) {
            return $property->class == get_class($this);
        });

        foreach ($ownProps as $value) {
            if($this->{$value->getName()}) {
                $this->{$value->getName()} = NULL;
            }
        }
    }

}