<?php

	namespace Apifon;
	require_once(__DIR__ . "/Resource/OAuthResource.php");

	use Apifon\Resource\OAuthResource;

	class OAuthRegistry
	{
		protected static $instance = null;
		public $identifier = [];
		public $token = [];

		public function __construct()
		{
			$instance = $this;
		}

		public static function getInstance()
		{

			if (null === self::$instance) {

				self::$instance = new OAuthRegistry();

			}
			return self::$instance;
		}

		public function add_OAuth_resource_and_get_token($identifier, $oauth_configuration)
		{
			$OAuthResource = new OAuthResource($oauth_configuration);

			$this->identifier[$identifier] = $oauth_configuration;

			$get_token = $OAuthResource->getTokensForClientCredentialsGrant();

			$this->token[$identifier] = $get_token["access_token"];
		}

		public function get_active_token($identifier)
		{
			$active_token = $this->token[$identifier];
			return $active_token;
		}


		public function remove_OAuth_resource($identifier)
		{
			$token = $this->token[$identifier];
			$oauth_configuration = $this->identifier[$identifier];

			$OAuthResource = new OAuthResource($oauth_configuration);
			$OAuthResource->revokeToken($token);
		}
	}
