<?php

namespace Apifon\Resource;

require_once("./Apifon/Response/BounceResponse.php");
require_once("./Apifon/Response/BounceResponseMulty.php");

use Apifon\Model\request\AddBounceSubscriberRequest;
use Apifon\Model\request\BounceQueryRequest;
use Apifon\Response\BounceResponse;
use Apifon\Response\BounceResponseMulty;
use \Exception;

class BounceResource extends AbstractResource {
    public function __construct() {
        parent::__construct($endpoint = "/services/api/v1/bounce/subscriber");
    }

    public function addBounceSubscriber($request)
    {
        $this->setCurMethod("POST");
        $this->setCurEndpoint($this->getEndpoint() . '/block');
        $this->setClearEndPoint($this->getEndpoint() . '/block');
        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof AddBounceSubscriberRequest){
            $this->setCurBody($request->getBody());
        }
        $response = json_decode(parent::dispatch(), true);
        return $response;
    }

    public function getBounceSubscribers($request)
    {
        $this->setCurMethod("GET");
        $this->setCurEndpoint($this->getEndpoint().$request->toQueryParamRequest());
        $this->setClearEndPoint($this->getEndpoint());
        $response = json_decode(parent::dispatch(), true);
        $result = new BounceResponseMulty($response);
        return $result;
    }

    public function getBounceSubscriber($request)
    {
        if(!$request->getDestination()) {
            throw new Exception("Destination of subscriber is not provided");
        }
        $this->setCurMethod("GET");
        $this->setCurEndpoint($this->getEndpoint() . '/' .$request->getDestination().$request->SingleFieldQueryParams());
        $this->setClearEndPoint($this->getEndpoint(). '/' .$request->getDestination());
        $return = json_decode(parent::dispatch(), true);
        $result = new BounceResponse($return);
        return $result;

    }

    public function removeBounceSubscriber(BounceQueryRequest $request)
    {
        if(!$request->getDestination()) {
            throw new Exception("Destination of subscriber is not provided");
        }
        $this->setCurMethod("DELETE");
        $this->setCurEndpoint($this->getEndpoint().'/unblock/'.$request->getDestination());
        $this->setClearEndPoint($this->getEndpoint().'/unblock/'.$request->getDestination());
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }
}