<?php

namespace Apifon\Resource;

use Apifon\Model\request\GdprFieldRequest;
use Apifon\Resource\AbstractResource;

use \Exception;
class GdprFieldResource extends AbstractResource
{
    public function __construct()
    {
        parent::__construct($endpoint = "/services/api/v1/list");
    }

    public function addGdprField($request)
    {
        if(!$request->getListId()) {
            throw new Exception('List id is missing, please setListId in request object');
        }
        $this->setCurMethod("POST");
        $this->setCurEndpoint($this->getEndpoint().'/'.$request->getListId().'/gdpr');
        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof GdprFieldRequest){
            $this->setCurBody($request->getBody());
        }
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }

    public function updateGdprField($request)
    {
        if(!$request->getListId()) {
            throw new Exception('List id is missing, please setListId in request object');
        }
        if(!$request->getfield()) {
            throw new Exception('Field identifier is missing, please setFieldId in request object');
        }
        $this->setCurMethod("PUT");
        $this->setCurEndpoint($this->getEndpoint().'/'.$request->getlistId().'/gdpr/'.$request->getField());
        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof GdprFieldRequest){
            $this->setCurBody($request->getBody());
        }
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }

}