<?php


namespace Apifon\Resource;

require_once("./Apifon/Response/GroupResponse.php");
require_once("./Apifon/Resource/AbstractResource.php");

use com\apifon\sdk\model\request\GroupRequest;




use \Exception;
use GroupResponse;


class GroupResource extends AbstractResource
{


       public function __construct()
    {
        parent::__construct($endpoint = "/services/api/v1/list/{list_id}/group");
    }

    public function replacePlaceholderAndSetUrl($endPoint, $listId)
    {
        $this->setClearEndPoint(str_replace( "{list_id}", $listId, $endPoint));
        $this->setCurEndpoint(str_replace( "{list_id}", $listId, $endPoint));
    }



     public function addGroup($request)
    {
        if ($request->getListId() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }
        $this->setCurMethod('POST');
        $this->replacePlaceholderAndSetUrl($this->getEndpoint() . "/", $request->getListId());

        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof GroupRequest){
            $this->setCurBody($request->getBody());
        }
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }

      public function updateGroup($request)
    {
        if ($request->getListId() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }
        $this->setCurMethod("PUT");
        $this->replacePlaceholderAndSetUrl($this->getEndpoint() . "/", $request->getListId());


        $this->setCurEndpoint($this->getCurEndpoint().$request->getGroupfield());
        $this->setClearEndpoint($this->getCurEndpoint());


        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof GroupRequest){
            $this->setCurBody($request->getBody());
        }
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }


        public function getGroup($request)
    {
        if ($request->getListId() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }
        $this->setCurMethod("GET");
        $this->replacePlaceholderAndSetUrl($this->getEndpoint() . "/", $request->getListId());


        $this->setCurEndpoint($this->getCurEndpoint().$request->getGroupfield());
        $this->setClearEndpoint($this->getCurEndpoint());
        $return = json_decode(parent::dispatch(), true);
        $result = new GroupResponse($return);
        unset($this->clearEndpoint);
        print_r($result);
        return $result;

    }

       public function removeGroup($request)
    {
        if ($request->getListId() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }
        $this->setCurMethod("DELETE");
        $this->replacePlaceholderAndSetUrl($this->getEndpoint() . "/", $request->getListId());


        $this->setCurEndpoint($this->getCurEndpoint().$request->getGroupfield());
        $this->setClearEndpoint($this->getCurEndpoint());

        $return = json_decode(parent::dispatch(), true);
        return $return;
    }
}



