<?php


namespace Apifon\Resource;

require_once("./Apifon/Response/ListResponse.php");
require_once("./Apifon/Response/ListResponseMulty.php");

use Apifon\Model\request\ListRequest;
use Apifon\Response\ListResponse;
use Apifon\Response\ListResponseMulty;
use \Exception;

class ListResource extends AbstractResource
{
    public function __construct()
    {
        parent::__construct($endpoint = "/services/api/v1/list");
    }

    public function addList($request)
    {
        $this->setCurMethod("POST");
        $this->setCurEndpoint($this->getEndpoint());
        $this->setClearEndpoint($this->getEndpoint());
        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof ListRequest){
            $this->setCurBody($request->getBody());
        }
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }

    public function getLists($request)
    {
        $this->setCurMethod("GET");
        $this->setCurEndpoint($this->getEndpoint().$request->toQueryParamRequest());
        $this->setClearEndPoint($this->getEndpoint());
        $this->setCurBody("");
        $return = json_decode(parent::dispatch(), true);
        $result = new ListResponseMulty($return);
        return $result;
    }

    public function getList($request)
    {
        if(!$request->getListId()) {
            throw new Exception("List Id is not provided, please setListId on request object.");
        }
        $this->setCurMethod("GET");
        $this->setCurEndpoint($this->getEndpoint().'/'.$request->getListId().$request->SingleFieldQueryParams());
        $this->setClearEndPoint($this->getEndpoint().'/'.$request->getListId());
        $return = json_decode(parent::dispatch(), true);
        $result = new ListResponse($return);
        unset($this->clearEndpoint);
        return $result;
    }

    public function updateList($request)
    {
        if(!$request->getListId()) {
            throw new Exception("List Id is not provided, please setListId on request object.");
        }
        $this->setCurMethod("PUT");
        $this->setCurEndpoint($this->getEndpoint().'/'.$request->getListId());
        $this->setClearEndpoint($this->getCurEndpoint());
        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof ListRequest){
            $this->setCurBody($request->getBody());
        }
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }

    public function removeList($request)
    {
        if(!$request->getListId()) {
            throw new Exception("List Id is not provided, please setListId on request object.");
        }
        $this->setCurMethod("DELETE");
        $this->setCurEndpoint($this->getEndpoint().'/'.$request->getListId());
        $this->setClearEndpoint($this->getCurEndpoint());
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }

}