<?php


namespace Apifon\Resource;

require_once("./Apifon/Response/GroupResponse.php");
require_once("./Apifon/Response/SubGroupResponse.php");

//use Apifon\Model\request\SubGroupRequest;
use Apifon\Model\request\ListRequest;
use Apifon\Response\GroupResponse;
use Apifon\Response\SubGroupResponse;
use com\apifon\sdk\model\request\SubGroupRequest;
use \Exception;


class SubGroupResource extends AbstractResource  {


       public function __construct()
    {
        parent::__construct($endpoint = "/services/api/v1/list/{list_id}/{group_field}");
    }
    public function replacePlaceholderAndSetUrlListID($endPoint, $listId)
    {
        $this->setClearEndPoint(str_replace( "{list_id}", $listId, $endPoint));
        $this->setCurEndpoint(str_replace( "{list_id}", $listId, $endPoint));
    }
    public function replacePlaceholderAndSetUrlGroupId($endPoint, $groupfield)
    {
        $this->setClearEndPoint(str_replace( "{group_field}", $groupfield, $endPoint));
        $this->setCurEndpoint(str_replace( "{group_field}", $groupfield, $endPoint));
    }

     public function addSubGroup($request)
    {


        if ($request->getListId() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }
        if ($request->getGroupfield() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }

        $this->setCurMethod('POST');
        $this->replacePlaceholderAndSetUrlListID($this->getEndpoint() , $request->getListId());

        $this->replacePlaceholderAndSetUrlGroupId($this->getCurEndpoint() , $request->getGroupfield().'/option');





        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof SubGroupRequest){
            $this->setCurBody($request->getBody());
        }
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }

    public function addSubGroups($request)
    {


        if ($request->getListId() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }
        if ($request->getGroupfield() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }

        $this->setCurMethod('POST');
        $this->replacePlaceholderAndSetUrlListID($this->getEndpoint() , $request->getListId());

        $this->replacePlaceholderAndSetUrlGroupId($this->getCurEndpoint() , $request->getGroupfield().'/options');





        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof SubGroupRequest){
            $this->setCurBody($request->getBody());
        }
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }







      public function updateSubGroup($request)
    {
        if ($request->getListId() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }
        if ($request->getGroupfield() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }

        $this->setCurMethod('PUT');
        $this->replacePlaceholderAndSetUrlListID($this->getEndpoint() , $request->getListId());

        $this->replacePlaceholderAndSetUrlGroupId($this->getCurEndpoint() , $request->getGroupfield()."/".$request->getOptionfield());

        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof SubGroupRequest){
            $this->setCurBody($request->getBody());
        }
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }

        public function getSubGroup($request)
    {
        if ($request->getListId() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }
        if ($request->getGroupfield() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }

        $this->setCurMethod('GET');
        $this->replacePlaceholderAndSetUrlListID($this->getEndpoint() , $request->getListId());

        $this->replacePlaceholderAndSetUrlGroupId($this->getCurEndpoint() , $request->getGroupfield().'/option'.'/'.$request->getOptionfield());


        $return = json_decode(parent::dispatch(), true);
        $result = new SubGroupResponse($return);
        unset($this->clearEndpoint);
        return $result;
    }

       public function removeSubGroup($request)
    {
        if ($request->getListId() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }
        if ($request->getGroupfield() == null) {
            throw new Exception("List id is missing, please setListId on request object.");
        }

        $this->setCurMethod('DELETE');
        $this->replacePlaceholderAndSetUrlListID($this->getEndpoint() , $request->getListId());

        $this->replacePlaceholderAndSetUrlGroupId($this->getCurEndpoint() , $request->getGroupfield()."/".$request->getOptionfield());
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }}


