<?php

namespace Apifon\Resource;

use Apifon\Model\request\SubscriberFieldRequest;
use Apifon\Model\UpdateSubscriberFieldRequest;
use \Exception;
class SubscriberFieldResource extends AbstractResource
{
    public function __construct() {
        parent::__construct($endpoint = "/services/api/v1/list");
    }

    public function addSubscriberField($request)
    {
        if(!$request->getListId()) {
            throw new Exception('List id is missing, please setListId in request object.');
        }
        $this->setCurMethod("POST");
        $this->setCurEndpoint($this->getEndpoint().'/'.$request->getListId().'/field');
        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof SubscriberFieldRequest){
            $this->setCurBody($request->getBody());
        }
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }

    public function updateSubscriberField($request)
    {
        if(!$request->getListId()) {
            throw new Exception('List id is missing, please setListId in request object.');
        }
        if(!$request->getField()) {
            throw new Exception('Field identifier is missing, please setField in request object.');
        }
        $this->setCurMethod("PUT");
        $this->setCurEndpoint($this->getEndpoint().'/'.$request->getListId().'/field/'.$request->getField());
        if(is_string($request)){
            $this->setCurBody($request);
        }
        elseif($request instanceof SubscriberFieldRequest){
            $this->setCurBody($request->getBody());
        }
        $return = json_decode(parent::dispatch(), true);
        return $return;

    }

    public function removeSubscriberField($request)
    {
        if(!$request->getListId()) {
            throw new Exception('List id is missing, please setListId in request object.');
        }
        if(!$request->getField()) {
            throw new Exception('Field identifier is missing, please setField in request object.');
        }
        $this->setCurMethod("DELETE");
        $this->setCurEndpoint($this->getEndpoint().'/'.$request->getListId().'/field/'.$request->getField());
        $return = json_decode(parent::dispatch(), true);
        return $return;
    }
}