<?php

namespace Apifon\Resource\helpers;

require_once("./Apifon/Resource/helpers/SortDirection.php");

use Apifon\Resource\helpers\SortDirection;

abstract class PaginatedRequest extends sortDirection
{
    protected $page = 1;
    protected $size = 200;
    protected $sort = "id";
    protected $sort_dir = 'ASC';

    public abstract function toQueryParamRequest();

    public abstract function SingleFieldQueryParams();

    public function getPathId()
    {
        return null;
    }

    /**
     * @return int
     */
    public function getPage()
    {
        return $this->page;
    }

    /**
     * @param int $page
     */
    public function setPage($page)
    {
        $this->page = $page;
    }

    /**
     * @return int
     */
    public function getSize()
    {
        return $this->size;
    }

    /**
     * @param int $size
     */
    public function setSize($size)
    {
        $this->size = $size;
    }

    /**
     * @return string
     */
    public function getSort()
    {
        return $this->sort;
    }

    /**
     * @param string $sortField
     */
    public function setSort($sort)
    {
        $this->sort = $sort;
    }

    /**
     * @param string $sort_dir
     */
    public function setSortDir($sort_dir)
    {
        $this->sort_dir = $sort_dir;
    }

    protected function addQueryParams($queryParams)
    {

    }

}