<?php

namespace Apifon\Response;

require_once("./Apifon/Model/GdprFieldResponseModel.php");
require_once("./Apifon/Model/FormUrls.php");
require_once("./Apifon/Model/CampaignDefaults.php");
require_once("./Apifon/Model/request/SubscriberFieldRequest.php");
require_once("./Apifon/Model/GdprProperties.php");


use Apifon\Model\CampaignDefaults;
use Apifon\Model\GdprFieldResponseModel;
use Apifon\Model\GdprProperties;
use Apifon\Model\request\FormUrls;
use Apifon\Model\request\SubscriberFieldRequest;


class ListResponse
{
    protected $meta;
    protected $id;
    protected $type;
    protected $title;
    protected $status;
    protected $description;
    protected $prefix;
    protected $account_id;
    protected $date_created;
    protected $date_updated;
    protected $campaign_defaults;
    protected $total_subscribers;
    protected $active_subscribers;
    protected $active_email_subscribers;
    protected $form_id;
    protected $subscriber_fields = array();
    protected $gdpr_fields = array();
    protected $brand_name;
    protected $company_name;
    protected $gdpr_properties;
    protected $form_urls;
    protected $groups;

    public function __construct($arrayResponse)
    {
        foreach ($arrayResponse as $key => $value) {
            if($key === 'campaign_defaults' && $value) {
                $this->campaign_defaults = new CampaignDefaults($value);
            } elseif($key === 'subscriber_fields') {
                foreach ($value as $fieldValues) {
                    $this->subscriber_fields[] = new SubscriberFieldRequest($fieldValues);
                }
            } elseif($key === 'gdpr_fields') {
                foreach ($value as $gdprValues) {
                    $this->gdpr_fields[] = new  GdprFieldResponseModel($gdprValues);
                }
            } elseif($key === 'gdpr_properties') {
                $this->gdpr_properties = new GdprProperties($value);
            } elseif($key === 'form_urls') {
                $this->form_urls = new FormUrls($value);
            } else {
                $this->{$key} = $value;
            }
        };
    }


    public function getMeta()
    {
        return $this->meta;
    }

    public function setMeta($meta)
    {
        $this->meta = $meta;
    }
    public function getGroups()
    {
        return $this->groups;
    }

    public function setGroups($groups)
    {
        $this->meta = $groups;
    }


    public function getId()
    {
        return $this->id;
    }

    public function setId($id)
    {
        $this->id = $id;
    }

    public function getType()
    {
        return $this->type;
    }

    public function setType($type)
    {
        $this->type = $type;
    }

    public function getTitle()
    {
        return $this->title;
    }

    public function setTitle($title)
    {
        $this->title = $title;
    }

    public function getStatus()
    {
        return $this->status;
    }

    public function setStatus($status)
    {
        $this->status = $status;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function setDescription($description)
    {
        $this->description = $description;
    }

    public function getPrefix()
    {
        return $this->prefix;
    }

    public function setPrefix($prefix)
    {
        $this->prefix = $prefix;
    }

    public function getAccountId()
    {
        return $this->account_id;
    }

    public function setAccountId($account_id)
    {
        $this->account_id = $account_id;
    }

    public function getDateCreated()
    {
        return $this->date_created;
    }

    public function setDateCreated($date_created)
    {
        $this->date_created = $date_created;
    }

    public function getDateUpdated()
    {
        return $this->date_updated;
    }

    public function setDateUpdated($date_updated)
    {
        $this->date_updated = $date_updated;
    }

    public function getCampaignDefaults()
    {
        return $this->campaign_defaults;
    }

    public function setCampaignDefaults($campaign_defaults)
    {
        $this->campaign_defaults = $campaign_defaults;
    }

    public function getTotalSubscribers()
    {
        return $this->total_subscribers;
    }

    public function setTotalSubscribers($total_subscribers)
    {
        $this->total_subscribers = $total_subscribers;
    }

    public function getActiveSubscribers()
    {
        return $this->active_subscribers;
    }

    public function setActiveSubscribers($active_subscribers)
    {
        $this->active_subscribers = $active_subscribers;
    }

    public function getActiveEmailSubscribers()
    {
        return $this->active_email_subscribers;
    }

    public function setActiveEmailSubscribers($active_email_subscribers)
    {
        $this->active_email_subscribers = $active_email_subscribers;
    }

    public function getFormId()
    {
        return $this->form_id;
    }

    public function setFormId($form_id)
    {
        $this->form_id = $form_id;
    }

    public function getSubscriberFields()
    {
        return $this->subscriber_fields;
    }

    /**
     * @param array $subscriber_fields
     */
    public function setSubscriberFields($subscriber_fields)
    {
        $this->subscriber_fields = $subscriber_fields;
    }

    /**
     * @return array
     */
    public function getGdprFields()
    {
        return $this->gdpr_fields;
    }

    /**
     * @param array $gdpr_fields
     */
    public function setGdprFields($gdpr_fields)
    {
        $this->gdpr_fields = $gdpr_fields;
    }

    /**
     * @return mixed
     */
    public function getBrandName()
    {
        return $this->brand_name;
    }

    /**
     * @param mixed $brand_name
     */
    public function setBrandName($brand_name)
    {
        $this->brand_name = $brand_name;
    }

    /**
     * @return mixed
     */
    public function getCompanyName()
    {
        return $this->company_name;
    }

    /**
     * @param mixed $company_name
     */
    public function setCompanyName($company_name)
    {
        $this->company_name = $company_name;
    }

    /**
     * @return mixed
     */
    public function getGdprProperties()
    {
        return $this->gdpr_properties;
    }

    /**
     * @param mixed $gdpr_properties
     */
    public function setGdprProperties($gdpr_properties)
    {
        $this->gdpr_properties = $gdpr_properties;
    }

    /**
     * @return mixed
     */
    public function getFormUrls()
    {
        return $this->form_urls;
    }

    /**
     * @param mixed $form_urls
     */
    public function setFormUrls($form_urls)
    {
        $this->form_urls = $form_urls;
    }
}