<?php


use Apifon\Mookee;
use Apifon\Resource\BounceResource;
use Apifon\Model\request\AddBounceSubscriberRequest;
use Apifon\Model\request\BounceQueryRequest;



require_once("../Apifon/Mookee.php");
require_once("../Apifon/Resource/BounceResource.php");
require_once("../Apifon/Model/request/AddBounceSubscriberRequest.php");
require_once("../Apifon/Model/request/BounceQueryRequest.php");
require_once("../Apifon/Resource/AbstractResource.php");
require_once("../Apifon/Security/Hmac.php");

Mookee::addCredentials("sms","Your_SMS_Token", "Your_SMS_Secret_Key");
Mookee::setActiveCredential("sms");

$bounceResource = new BounceResource();
$bounceQueryRequest = new BounceQueryRequest();
$addBounceSubscriberRequest = new AddBounceSubscriberRequest();
//GET BOUNCED SUBSCRIBERS
function getBounceSubscribers($bounceResource, $bounceQueryRequest) {

    $bounceQueryRequest->setType("MOBILE");
    $bounceQueryRequest->setReason("other");
    $bounceQueryRequest->setPage(1);
    //Response will include destination and type properties of the bounced subscribers'
    $bounceQueryRequest->setFields("destination", "type");
    $bounceQueryRequest->setSort("dateCreated");
    $bounceQueryRequest->setSortDir("ASC");

    return $bounceResource->getBounceSubscribers($bounceQueryRequest);
}
//GET A BOUNCED SUBSCRIBER
function getBounceSubscriber($bounceResource, $bounceQueryRequest, $bounceSubscribers)
{
    //Clear Request object if you don't want to keep the same properties from the previous request;
    $bounceQueryRequest->clearObj();
    //Get the first subscriber of the returned response;
    $bounceSubscriber = $bounceSubscribers->getResults()[0];
    $bounceQueryRequest->setDestination($bounceSubscriber->getDestination());
    return $bounceResource->getBounceSubscriber($bounceQueryRequest);
}
//REMOVE A BOUNCED SUBSCRIBER
function removeBouncedSubsbscriber($bounceResource, $bounceQueryRequest, $bounceSubscriber)
{
    $bounceQueryRequest->clearObj();
    $bounceQueryRequest->setDestination($bounceSubscriber->getDestination());
    $bounceResource->removeBounceSubscriber($bounceQueryRequest);
}
//ADD A BOUNCED SUBSCRIBER
function addBouncedSubscriber($bounceResource, $addBounceSubscriberRequest)
{
    $addBounceSubscriberRequest->clearObj();
    $addBounceSubscriberRequest->setDestination('111111111');
    $addBounceSubscriberRequest->setReason('other');
    $addBounceSubscriberRequest->setDescription('Write a description');
    $bounceResource->addBounceSubscriber($addBounceSubscriberRequest);
}

//$bounceSubscribers = addBouncedSubscriber($bounceResource, $addBounceSubscriberRequest);
//$bounceSubscribers = getBounceSubscribers($bounceResource, $bounceQueryRequest);
//$bounceSubscriber = getBounceSubscriber($bounceResource, $bounceQueryRequest, $bounceSubscribers);
//removeBouncedSubsbscriber($bounceResource, $bounceQueryRequest, $bounceSubscriber);
//var_dump($bounceSubscriber);

