<?php

use Apifon\Mookee;
use Apifon\Resource\ListResource;
use Apifon\Model\request\ListRequest;
use Apifon\Model\request\ListQueryRequest;
use Apifon\Resource\SubscriberFieldResource;
use Apifon\Model\request\SubscriberFieldRequest;
use Apifon\Resource\GdprFieldResource;
use Apifon\Model\request\GdprFieldRequest;
use Apifon\Resource\SubscriberResource;
use Apifon\Model\request\SubscriberQueryRequest;
use Apifon\Model\request\QuerySubscribersBodyRequest;
use Apifon\Model\request\SubscriberUpdateRemoveRequest;
use Apifon\Model\request\SubscriberRequest;
use Apifon\Resource\GroupResource;
use Apifon\Resource\SubGroupResource;

use com\apifon\sdk\model\request\GroupRequest;
use com\apifon\sdk\model\request\SubGroupRequest;

require_once("../Apifon/Mookee.php");
require_once("../Apifon/Security/Hmac.php");
require_once("../Apifon/Resource/AbstractResource.php");
require_once("../Apifon/Resource/ListResource.php");
require_once("../Apifon/Model/request/ListRequest.php");
require_once("../Apifon/Model/request/ListQueryRequest.php");
require_once("../Apifon/Resource/SubscriberFieldResource.php");
require_once("../Apifon/Model/request/SubscriberFieldRequest.php");
require_once("../Apifon/Resource/GdprFieldResource.php");
require_once("../Apifon/Model/request/GdprFieldRequest.php");
require_once("../Apifon/Resource/SubscriberResource.php");
require_once("../Apifon/Model/request/SubscriberQueryRequest.php");
require_once("../Apifon/Model/request/QuerySubscribersBodyRequest.php");
require_once("../Apifon/Model/request/SubscriberUpdateRemoveRequest.php");
require_once("../Apifon/Model/request/SubscriberRequest.php");
require_once("../Apifon/Model/request/GroupRequest.php");
require_once("../Apifon/Resource/GroupResource.php");
require_once("../Apifon/Model/request/SubGroupRequest.php");
require_once("../Apifon/Resource/SubGroupResource.php");

$listResource = new ListResource();
$listQueryRequest = new ListQueryRequest();
$listRequest = new ListRequest();
$subscriberFieldResource = new SubscriberFieldResource();
$subscriberFieldRequest = new SubscriberFieldRequest();
$gdprFieldResource = new GdprFieldResource();
$gdprFieldRequest = new GdprFieldRequest();
$subscriberResource = new SubscriberResource();
$subscriberQueryRequest = new SubscriberQueryRequest();
$querySubscribersBodyRequest = new QuerySubscribersBodyRequest();
$subscriberUpdateRemoveRequest = new SubscriberUpdateRemoveRequest();
$subscriberRequest = new SubscriberRequest();
$groupResource = new GroupResource();
$groupRequest = new GroupRequest() ;
$subgroupResource = new SubGroupResource();
$subgroupRequest = new SubGroupRequest() ;

Mookee::addCredentials("sms","Your_SMS_Token", "Your_SMS_Secret_Key");
Mookee::setActiveCredential("sms");

//Get lists
function getLists($listResource, $listQueryRequest)
{
    $listQueryRequest->setType("ADVANCED");
    $listQueryRequest->setPage(1);
    $listQueryRequest->setSize(20);
    $listQueryRequest->setSort("dateCreated");
    $listQueryRequest->setSortDir("ASC");
    return $listResource->getLists($listQueryRequest);
}

//Get a specific list
function getList($listResource, $listQueryRequest, $lists)
{
    $list = $lists->getResults()[0];
    //Clear listQueryRequest object
    $listQueryRequest->clearObj();
    $listQueryRequest->setListId($list->getId());
    //Get only campaign_defaults of a specific list
    $listQueryRequest->setFields('campaign_defaults');
    return $listResource->getList($listQueryRequest);
}


// Add a group
function addGroup($groupResource, $groupRequest,$list)
{
    $groupRequest->setListId($list->getId());
    $groupRequest->setGroupOptionsOrientation("VERTICAL");
    $groupRequest->setSelectionType("SINGLE");
    $groupRequest->setInternal("False");
    $groupRequest->setType("GROUP");
    $groupRequest->setName("Set the Group Name");
    return $groupResource->addGroup($groupRequest);

}
//Get a group
function getGroup($groupResource, $groupRequest,$list)
{
    $groupRequest->setListId($list->getId());

// In lines 77 and 78 we get printed the groups and all the info for the groups of the specific list ,
//choose the group field from the group that you want and add it in line 80
//    $groups= $list->getGroups();
//    print_r($groups);

    $groupRequest->setGroupfield("Set the Group Field of the Group");
    return $groupResource->getGroup($groupRequest);
}
//Remove a group
function removeGroup($groupResource, $groupRequest,$list)
{
    $groupRequest->setListId($list->getId());

// In lines 91 and 92 we get printed the groups and all the info for the groups of the specific list ,
//choose the group field from the group that you want and add it in line 94

//    $groups= $list->getGroups();
//    print_r($groups);

    $groupRequest->setGroupfield("Set the Group Field of the Group");
    $groupResource->removeGroup($groupRequest);
}
// Update a group
function updateGroup($groupResource, $groupRequest,$list)
{
    $groupRequest->setListId($list->getId());

// In lines 105 and 106 we get printed the groups and all the info for the groups of the specific list ,
//choose the group field from the group that you want and add it in line 111

//    $groups= $list->getGroups();
//    print_r($groups);
    $groupRequest->setGroupOptionsOrientation("VERTICAL");
    $groupRequest->setSelectionType("SINGLE");
    $groupRequest->setInternal("False");
    $groupRequest->setType("GROUP");
    $groupRequest->setGroupfield("Set the Group Field of the Group");
    $groupRequest->setType("Set the Group Type");
    $groupRequest->setName("Set the Group Name");
    return $groupResource->updateGroup($groupRequest);

}
//Add a sub group
function addSubGroup($subgroupResource, $subgroupRequest,$list)
{
    $subgroupRequest->setListId($list->getId());

// In lines 125 and 126 we get printed the groups and all the info for the groups of the specific list ,
//choose the group field from the group that you want and add it in line 128

//    $groups= $list->getGroups();
//    print_r($groups);

    $subgroupRequest->setGroupfield("Set the Group Field of the Group");
    $subgroupRequest->setName("Set the SubGroup Name");
    return $subgroupResource->addSubGroup($subgroupRequest);

}
//Get a sub group
function getSubGroup($subgroupResource, $subgroupRequest,$list)
{

    $subgroupRequest->setListId($list->getId());

// In lines 142 and 143 we get printed the groups and all the info for the groups of the specific list ,
//choose the group field and the option field from the group that you want and add it in line 145 and 146

//    $groups= $list->getGroups();
//    print_r($groups);

    $subgroupRequest->setGroupfield("Set the Group Field of the Group");
    $subgroupRequest->setOptionfield("Set the Option Field of the SubGroup");

    return $subgroupResource->getSubGroup($subgroupRequest);

}

//Update a sub group
function updateSubGroup($subgroupResource, $subgroupRequest,$list)
{

    $subgroupRequest->setListId($list->getId());

// In lines 161 and 162 we get printed the groups and all the info for the groups of the specific list ,
//choose the group field and the option field from the group that you want and add it in line 164 and 165

//    $groups= $list->getGroups();
//    print_r($groups);

    $subgroupRequest->setGroupfield("Set the Group Field of the Group");
    $subgroupRequest->setOptionfield("Set the Option Field of the SubGroup");
    $subgroupRequest->setName("Set the SubGroup Name");
    return $subgroupResource->updateSubGroup($subgroupRequest);

}
//Delete a sub group
function removeSubGroup($subgroupResource, $subgroupRequest,$list)
{

    $subgroupRequest->setListId($list->getId());

// In lines 179 and 180 we get printed the groups and all the info for the groups of the specific list ,
//choose the group field and the option field from the group that you want and add it in line 182 and 183

//    $groups= $list->getGroups();
//    print_r($groups);

    $subgroupRequest->setGroupfield("Set the Group Field of the Group");
    $subgroupRequest->setOptionfield("Set the Option Field of the SubGroup");

    return $subgroupResource->removeSubGroup($subgroupRequest);

}

//Add subgroups
function addSubGroups($subgroupResource, $subgroupRequest,$list)
{
//
    $subgroupRequest->setListId($list->getId());

// In lines 198 and 199 we get printed the groups and all the info for the groups of the specific list ,
//choose the group field from the group that you want and add it in line 201

//    $groups= $list->getGroups();
//    print_r($groups);

    $subgroupRequest->setGroupfield("Set the Group Field of the Group");
    $subgroupRequest->setName(["Set the SubGroup Name No1","Set the SubGroup Name No2"]);
    return $subgroupResource->addSubGroups($subgroupRequest);

}
function addSubscriber($subscriberResource, $subscriberRequest, $list)
{
    $subscriberRequest->setListId($list->getId());
    $subscriberRequest->setDestination("306973954742");
    $subscriberRequest->setStatus("SUBSCRIBED");

    //Add values to subscriber fields
//    $subscriberRequest->setSubscriberFields(array("FIRST_NAME"=> "Jonathan", "GENDER" => "Male"));
    //Instantiate a gdprFieldConsent object
    $gdprFieldConsent = $subscriberRequest->gdprFieldConsentBuilder();
    //Set mobile or email consent
    $gdprFieldConsent->setMobile(true);
    //Create an associative array as property insert the name of gpdr field and as value the gdprFieldConsent object
//    $subscriberRequest->setGdprFields(array("GDPR_FIELD_TEST" => $gdprFieldConsent));
    $subscriberRequest->setGroupOptions("Set the Option Field of the SubGroup","Set the Option Field of the SubGroup");
    $subscriberResource->addSubscriber($subscriberRequest);
}

//update a subscriber from a specific list
function updateSubscriber($subscriberResource, $subscriberUpdateRemoveRequest, $list, $subscriber)
{
    $subscriberUpdateRemoveRequest->setListId($list->getId());
    $subscriberUpdateRemoveRequest->setDestination("306973954742");
    $subscriberUpdateRemoveRequest->setStatus("SUBSCRIBED");
    //Set for LookupMd5 the destinationId or emailId of the subscriber
    $subscriberUpdateRemoveRequest->setLookupMd5($subscriber->getDestinationId());
    //Add values to subscriber fields
//    $subscriberUpdateRemoveRequest->setSubscriberFields(array("FIRST_NAME"=> "Jonathan", "GENDER" => "Male"));
    //Instantiate a gdprFieldConsent object
    $gdprFieldConsent = $subscriberUpdateRemoveRequest->gdprFieldConsentBuilder();
    //Set mobile or email consent
    $gdprFieldConsent->setMobile(false);
    //Create an associative array as property insert the name of gpdr field and as value the gdprFieldConsent object
    $subscriberUpdateRemoveRequest->setGdprFields(array("PROMOTION" => $gdprFieldConsent));
    $subscriberUpdateRemoveRequest->setGroupOptionssetGroupOptions("Set the Option Field of the SubGroup","Set the Option Field of the SubGroup");
    $subscriberResource->updateSubscriber($subscriberUpdateRemoveRequest);
}






//get Lists , get a List calls

//$lists = getLists($listResource, $listQueryRequest);
//$list = getList($listResource, $listQueryRequest, $lists);

//subgroups calls

//addSubGroups($subgroupResource, $subgroupRequest,$list);
//addSubGroup($subgroupResource, $subgroupRequest,$list);
//getSubGroup($subgroupResource, $subgroupRequest,$list);
//updateSubGroup($subgroupResource, $subgroupRequest,$list);
//removeSubGroup($subgroupResource, $subgroupRequest,$list);

//group calls

//addGroup($groupResource,$groupRequest,$list);
//removeGroup($groupResource, $groupRequest,$list);
//getGroup($groupResource, $groupRequest,$list);
//updateGroup($groupResource, $groupRequest,$list);

//subscriber calls

//addSubscriber($subscriberResource, $subscriberRequest, $list);
//getSubscriber($subscriberResource, $subscriberQueryRequest, $list);
//updateSubscriber($subscriberResource, $subscriberUpdateRemoveRequest, $list, $subscriber);



