<?php

use Apifon\Mookee;
use Apifon\Resource\ListResource;
use Apifon\Model\request\ListRequest;
use Apifon\Model\request\ListQueryRequest;
use Apifon\Model\request\OAuthConfigurationRequest;


require_once("./Apifon/Mookee.php");
require_once("./Apifon/Resource/AbstractResource.php");
require_once("./Apifon/Resource/ListResource.php");
require_once("./Apifon/Model/request/ListRequest.php");
require_once("./Apifon/Model/request/ListQueryRequest.php");
require_once("./Apifon/Model/request/OAuthConfigurationRequest.php");




$listResource = new ListResource();
$listQueryRequest = new ListQueryRequest();
$listRequest = new ListRequest();



//Get lists
function getLists($listResource, $listQueryRequest)
{
    $listQueryRequest->setType("ADVANCED");
    $listQueryRequest->setPage(1);
    $listQueryRequest->setSize(20);
    $listQueryRequest->setSort("dateCreated");
    $listQueryRequest->setSortDir("ASC");
    return $listResource->getLists($listQueryRequest);
}




//Get a specific list
function getList($listResource, $listQueryRequest, $lists)
{
    $list = $lists->getResults()[0];
    //Clear listQueryRequest object
    $listQueryRequest->clearObj();
    $listQueryRequest->setListId($list->getId());
    //Get only campaign_defaults of a specific list
    $listQueryRequest->setFields('campaign_defaults');
    return $listResource->getList($listQueryRequest);
}


function clientCredentialsGrantExample(){
    $oauth_identifier_list="Type an identifier name";


    $oauth_configuration= new OAuthConfigurationRequest("Type your ClientId",
        "Type your ClientSecret");

    //setStaging to true or false , true is for staging and false is for production url
    Mookee::setStaging(false);
    Mookee::add_OAuth_resource_and_get_token($oauth_identifier_list,$oauth_configuration);
    Mookee::set_mookee_to_oauth_mode($oauth_identifier_list, True);
    Mookee::getActive_oauth_token_to_make_an_API_call($oauth_identifier_list);

//    Mookee::remove_OAuth_resource($oauth_identifier_list);



    return;
}



clientCredentialsGrantExample();
$lists = getLists($listResource, $listQueryRequest);
print_r($lists);
////$list = getList($listResource, $listQueryRequest, $lists);