<?php

use Apifon\Mookee;
use Apifon\Model\SmsRequest;
use Apifon\Model\MessageContent;
use Apifon\Resource\SMSResource;

require_once("./Apifon/Model/IRequest.php");
require_once("./Apifon/Model/SubscribersViewRequest.php");
require_once("./Apifon/Mookee.php");
require_once("./Apifon/Security/Hmac.php");
require_once("./Apifon/Resource/AbstractResource.php");
require_once("./Apifon/Resource/SMSResource.php");
require_once("./Apifon/Response/GatewayResponse.php");
require_once("./Apifon/Model/MessageContent.php");
require_once("./Apifon/Model/SmsRequest.php");
require_once("./Apifon/Model/SubscriberInformation.php");

Mookee::addCredentials("sms","Your_SMS_Token", "Your_SMS_Secret_Key");
Mookee::setActiveCredential("sms");

$smsResource = new SMSResource();
$smsRequest = new SmsRequest();

$nums = ["306999999999", /*"306999999998", "306999999997", ...*/];

$message = new MessageContent();
$message->setText("Hello there!");
$message->setSenderId("Apifon");

$smsRequest->setStrSubscribers($nums);
$smsRequest->setMessage($message);

echo "Sending Request to Endpoint: /services/sms/send" . "\xA";
echo "------ SMS Request Body ------" . "\xA";
printJson($smsRequest);
$response = $smsResource->send($smsRequest);
echo "------ Gateway Response Body ------" . "\xA";
printJson($response);

function printJson($json){
    $res = preg_replace('/,\s*"[^"]+":null|"[^"]+":null,?/', '', json_encode(get_object_vars($json)));
    $res = json_decode($res);
    echo json_encode($res, JSON_PRETTY_PRINT) . "\xA";
}